﻿/// Copyright © 2013 Microsoft Corporation. 
/// This project is released under the Microsoft Public License (MS-PL)
///
namespace DataMorph.Common.Entities
{
    using System;

    using Microsoft.WindowsAzure.Storage.Table;

    public class ProcessingRecordEntity : TableEntity
    {
        public string StorageAccount { get; set; }

        public string DataSet { get; set; }

        public string DeploymentId { get; set; }

        public string InstanceId { get; set; }

        public double AverageParseTime { get; set; }

        public double AverageWriteTime { get; set; }

        public double MaxParseTime { get; set; }

        public double MaxWriteTime { get; set; }

        public double MinParseTime { get; set; }

        public double MinWriteTime { get; set; }

        public DateTimeOffset TimeRequested { get; set; }

        public DateTimeOffset CompletedTime { get; set; }

        public double TotalProcessingTime { get; set; }

        public double AverageReadTime { get; set; }

        public double MaxReadTime { get; set; }

        public double MinReadTime { get; set; }

        public int FilesRead { get; set; }

        public int FilesWritten { get; set; }

        public int InstanceCount { get; set; }

        public int CoreCount { get; set; }

        public int BatchSize { get; set; }
    }
}